<?php

	class Template
	{
		var $Resources = array( );
		var $TplDir;
		
		function Template( $_Dir ) //no constructor atm
		{
			$this -> TplDir = $_Dir;
		}

		function OpenResource( $_ResFile )
		{
			$_ResFile = $this -> TplDir . $_ResFile . '.html';
			$_ResId = count( $this -> Resources );
			$this -> Resources[ $_ResId ][ 'handle' ] = @fopen( $_ResFile, 'r' );
			if( !$this -> Resources[ $_ResId ] ) $this -> RaiseError( 'Could not find ' . $_ResFile, 'Could not find ' . $_ResFile, false );
			$this -> Resources[ $_ResId ][ 'content' ] = @fread( $this -> Resources[ $_ResId ][ 'handle' ], filesize( $_ResFile ) );
			$this -> Resources[ $_ResId ][ 'org_content' ] = $this -> Resources[ $_ResId ][ 'content' ];
			return $_ResId;
		}
		
		function DestroyResource( $_ResId )
		{
			@fclose( $this -> Resources[ $_ResId ][ 'handle' ] );
		}
		
		function SetVars( $_ResId, $_Vars, $_IsBlock = false )
		{
			foreach( $_Vars as $_VarName => $_VarValue )
			{
				if( !$_IsBlock )
					$this -> Resources[ $_ResId ][ 'content' ] = str_replace( '[' . $_VarName . ']', $_VarValue, $this -> Resources[ $_ResId ][ 'content' ] ); 
				else
				{
					$this -> Resources[ $_ResId ][ 'content' ] = str_replace( '[' . $this -> Resources[ $_ResId ][ 'block_name' ] . '.' . $_VarName . ']', $_VarValue, $this -> Resources[ $_ResId ][ 'content' ] ); 
				}
			}
		}
		
		var $BlocksStack = array();
		
		function Out( $_ResId )
		{
			if( $this -> Resources[ $_ResId ][ 'is_block' ] )
			{
				$_Parent = $this -> Resources[ $_ResId ][ 'parent' ];
				$_Name   = $this -> Resources[ $_ResId ][ 'block_name' ];
				$this -> BlocksStack[ $_Parent ][ 'content' ] .= $this -> Resources[ $_ResId ][ 'content' ];
				$this -> BlocksStack[ $_Parent ][ 'name' ]     = $_Name;
				$this -> Resources[ $_ResId ][ 'content' ] = $this -> Resources[ $_ResId ][ 'org_content' ];
			}
			else
			{
				foreach( $this -> BlocksStack as $_BlockStack )
				{
					$_Name = $_BlockStack [ 'name' ];
					$_Pattern = '/<!-- START ' . $_Name . ' -->(.*?)<!-- END ' . $_Name . ' -->/s';
					$this -> Resources[ $_ResId ][ 'content' ] = preg_replace( $_Pattern, $_BlockStack[ 'content' ], $this -> Resources[ $_ResId ][ 'content' ] );
				}
				echo $this -> Resources[ $_ResId ][ 'content' ];
			}
		}
		
		function GetBlock( $_ResId, $_Name )
		{
			$_Parent = $_ResId;
			if( preg_match( '/<!-- START ' . $_Name . ' -->(.*?)<!-- END ' . $_Name . ' -->/s', $this -> Resources[ $_ResId ][ 'content' ], $_ERes ) )
			{
				$_ResId = count( $this -> Resources );
				$this -> Resources[ $_ResId ][ 'content' ]     = $_ERes[ 1 ];
				$this -> Resources[ $_ResId ][ 'org_content' ] = $this -> Resources[ $_ResId ][ 'content' ];
				$this -> Resources[ $_ResId ][ 'is_block' ]    = true;
				$this -> Resources[ $_ResId ][ 'block_name' ]  = $_Name;
				$this -> Resources[ $_ResId ][ 'parent' ]      = $_Parent;
				return $_ResId;
			}
		}
		
		function RaiseError( $_Error, $_Description, $_Critical )
		{
			$_ErrorTemplate  = '<html><head><title>';
			$_ErrorTemplate .= 'Database error: ' . $_Error . '</title>';
			$_ErrorTemplate .= '</head><body>';
			$_ErrorTemplate .= '<h1>' . $_Error . '</h1><br>';
			$_ErrorTemplate .= '<h3>' . $_Description . '</h3>';
			$_ErrorTemplate .= '</body></html>';
			if( $_Critical )
				die( $_ErrorTemplate );
			else
				echo $_Critical;
		}
		
		function Destroy( )
		{
			unset( $this -> BlocksStack );
			unset( $this -> Resources );
		}
	}

?>